/*  Programa:		NewBur.cpp, creado en TC++ 3.0
    Autor:		Manass Jess Galindo Bello
			Universidad Tecnolgica de la Mixteca
			Huajuapan de Len, Oaxaca, Mxico
			e-mails:
			  - ic012183@ndikandi.utm.mx
			  - manases@tepasasdeveras.com
			  - CBoyF1@hotmail.com  <---- Para conversar por
						      el messenger


    Este es el mtodo de la burbuja con una optimizacin que revisa
    si hay elementos ordenados, lo que ahorra comparaciones y nmero
    de vueltas a los ciclos.
    Utiliza arreglos con una constante (MAX) que indica el nmero mximo
    de nmeros a ordenar.
*/

#include <stdio.h>
#include <conio.h>

#define MAX 10

void burbuja (void);
int  compara (int [], int *);

void main ()
{
   clrscr();
   burbuja();
}

void burbuja (void)
{
   int i, p, h, a[MAX], pos= 1;

   for (i=0; i<MAX; i++)
      {
	 printf("Introduce el nmero %d: ",i+1);
	 scanf("%d",&a[i]);
      }

   while (compara(a,&pos));
   for (p=1; p<=MAX-pos; p++)
      for (i=0; i<=MAX-pos-1; i++)
	 if (a[i] > a[i+1])
	    {
	       h= a[i];
	       a[i]= a[i+1];
	       a[i+1]= h;
	    }

   printf("Valores ordenados: ");
   for (i=0; i<MAX; i++)
      printf("%d ",a[i]);

   getch();
}

int compara (int a[], int *pos)
{
   int i;

   for (i=0; i<MAX-(*pos); i++)
      if (a[MAX-(*pos)] < a[i])
	 return 0;

   if (*pos < MAX)
      return ++(*pos);
   else
      return 0;
}